CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  basepin       = 12

  CLS           = $00  'clear screen
  HOME          = $01  'home
  CRSRXY        = $02  'set X, Y position (X, Y follow)
  CRSRLF        = $03  'cursor left
  CRSRRT        = $04  'cursor right
  CRSRUP        = $05  'cursor up
  CRSRDN        = $06  'cursor dn
  USECLR        = $07  'use color C (C follows)
  BS            = $08  'backspace
  TAB           = $09  'tab (8 spaces per)
  LF            = $0A  'linefeed
  CLREOL        = $0B  'clear to end of line
  CLRDN         = $0C  'clear down (to end of window)
  CR            = $0D  'return
  CRSRX         = $0E  'set X position (X follows)
  CRSRY         = $0F  'set Y position (Y follows)
  DEFWIN        = $10  'define window  W (W, Left, Top, nCols, nRows follow)
  USEWIN        = $11  'use window W (W follows)
  DEFCLR        = $12  'define color C (C, FG, BG follow)
  SCRLLF        = $13  'scroll window left
  SCRLRT        = $14  'scroll window right
  SCRLUP        = $15  'scroll window up
  SCRLDN        = $16  'scroll window down
  CHGCLR        = $17  'change all colors in window to C (C follows)
  CLRW          = $1E  'same as CLR, but can be used in strings.
  ESC           = $1F  'escape next character C (i.e. print as-is) (C follows)
  ZERO          = $FF  'can be used for 0, which is not allowed in strings, for command arguments

OBJ

  pr : "tv_wtext"

PUB start | i

  pr.start(basepin | pr#CHANNEL3 | pr#MUTE)   'Use this to demo broadcast video with sound effects.
  'pr.start(basepin)                           'Use this to demo baseband video.
  pause(2)
  beep(150, 400)
  beep(150, 500)
  pr.str(string(DEFWIN, 15, ZERO, ZERO, 40, 4, DEFCLR, 1, $03, $03, USECLR, 1, CHGCLR, 1, CRSRXY, 4, 6, "This is a demo of tv_wtext.spin."))
  repeat i from $03 to $07
    pr.str(string(DEFCLR, 1))
    pr.out(i)
    pr.out($03)
    pause(-15)
  pause(2)
  repeat i from $07to $03
    pr.str(string(DEFCLR, 1))
    pr.out(i)
    pr.out($03)
    pause(-15)
  pause(2)
  pr.out(0)
  pr.str(string(USEWIN, 15, USECLR, 4, "The 'w' stands for 'windows'.", CR))
  pause(2)
  pr.str(string("A window is a sub-region of the screen", CR, "that can be controlled independently,", CR))
  pause(2)
  pr.str(string("like this:"))
  pause(1)
  pr.str(string(DEFWIN, 1, 16, 5, 8, 6, USEWIN, 1, CHGCLR, 15))
  pause(-2)
  repeat i from 1000 to 1025
    pr.str(string(CR, "   "))
    pr.dec(i)
    beep(10, 1000)
    pause(-5)
  pause(1)
  pr.str(string(USEWIN, 15, CLRW))
  pause(1)
  pr.str(string("Windows can be scrolled left,"))
  pause(1)
  pr.str(string(USEWIN, 1))
  repeat 3
    pr.out(SCRLLF)
    beep(100,1000)
    pause(-4)
  pr.str(string(USEWIN, 15))
  pr.str(string(" right,"))
  pause(1)
  pr.str(string(USEWIN, 1))
  repeat 3
    pr.out(SCRLRT)
    beep(100,750)
    pause(-4)
  pr.str(string(USEWIN, 15))
  pr.str(string(CR, "up,"))
  pause(1)
  pr.str(string(USEWIN, 1))
  repeat 3
    pr.out(SCRLUP)
    beep(100,750)
    beep(100,1000)
    pause(-4)
  pr.str(string(USEWIN, 15))
  pr.str(string(" or down."))
  pause(1)
  pr.str(string(USEWIN, 1))
  repeat 3
    pr.out(SCRLDN)
    beep(100,1000)
    beep(100,750)
    pause(-4)
  pause(2)
  pr.str(string(DEFWIN, 2, ZERO, 12, 40, 1, USEWIN, 2, CHGCLR, $0E, CRSRX, 39))
  marquee(string("Scrolling is handy for creating things like marquees....."), -10, 40)
  pause(1)
  pr.str(string(USEWIN, 15, CLRW))
  pause(1)
  pr.str(string("Colors can be controlled ", USECLR, 11, "independently", USECLR, 4, CR))
  pause(3)
  pr.str(string("or over the entire window at once."))
  pause(3)
  repeat i from 2 to 15
    pr.out(CHGCLR)
    pr.out(i)
    beep(10, 500)
    pause(-2)
  pr.str(string(CHGCLR, 4))
  pause(1)
  pr.str(string(USEWIN, 15, CLRW))
  pause(1)
  pr.str(string("Any color can also be altered, affecting", CR, "every instance of that color on the", CR, "screen."))
  pause(4)
  pr.str(string(" This can be handy for flashing a", CR, CRSRX, 16, USECLR, 9, "WARNING!"))
  repeat 6
    beep(500, 40)
    pr.str(string(DEFCLR, 9, 3, 3))
    pause(-2)
    pr.str(string(DEFCLR, 9, 3, $0E))
  beep(500, 40)
  pr.str(string(DEFCLR, 9, 3, 3))
  pause(2)
  pr.str(string(USEWIN, ZERO, CLRW, USECLR, 1, CRSRXY, 3, 5))
  pause(2)
  pr.str(string(CRSRX, 7, "Many thanks to Chip Gracey,", CR, "    upon whose tv and tv_text objects", CR, CRSRX, 9, "this object was built."))
  repeat i from $03 to $07
    pr.str(string(DEFCLR, 1))
    pr.out(i)
    pr.out($03)
    pause(-15)
  pause(10)
  repeat i from $07to $03
    pr.str(string(DEFCLR, 1))
    pr.out(i)
    pr.out($03)
    pause(-15)
  beep(150, 500)
  beep(150, 400)
  repeat

PRI beep(millisec, freq) | audio, fm
  millisec := millisec * freq / 1000
  freq <<= 1
  audio := frqa
  fm := audio >> 7
  repeat millisec
    waitcnt(cnt + clkfreq / freq)
    frqa := audio + fm 
    waitcnt(cnt + clkfreq / freq)
    frqa := audio - fm
  frqa := audio                    

PRI marquee(str_addr, delay, extras) | i

  repeat i from 0 to strsize(str_addr) - 1
    pr.out(byte[str_addr][i])
    beep(5, 200)
    pause(delay)
    pr.str(string(SCRLLF, CRSRLF))
  repeat extras
    pr.out(" ")
    beep(5, 200)
    pause(delay)
    pr.str(string(SCRLLF, CRSRLF))  

PRI pause(t)

  if t < 0
    t := clkfreq / ||t
  else
    t *= clkfreq
  waitcnt(t + cnt)
    